#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
using ll = long long;

vector<vector<short>> field;
vector<vector<bool>> field1;
vector<pair<short, short>> vecs;
ll n, m, k;
ll ans;

void rec(ll x, ll y, ll l, ll z, ll c) {
    if (l == z) {
        if (x == 0 && y == 0 && field[n - 1][m - 1] == 1 && c == k) {
            ans++;
        }
        return;
    }
    field[y][x] = 1;
    if (field1[y][x]) {
        c++;
    }
    for (pair<short, short> p : vecs) {
        if (p.first + x < m && p.second + y < n && p.first + x >= 0 && p.second + y >= 0) {
            if (field[p.second + y][p.first + x] == 0 || p.second + y == 0 && p.first + x == 0) {
                rec(x + p.first, p.second + y, l + 1, z, c);
            }
        }
    }
    field[y][x] = 0;
}


int main() {
    ll x, y;
    ans = 0;
    cin >> n >> m >> k;
    field.resize(n, vector<short>(m, 0));
    field1.resize(n, vector<bool>(m, false));
    for (ll i = 0; i < k; i++) {
        cin >> x >> y;
        field1[x - 1][y - 1] = true;
    }
    vecs = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
    rec(0, 0, 0, 2 * n + 2 * m - 4, 0);
    cout << ans << endl;
    return 0;
}
